// TODO: tooltips?
// TODO: do column colors in JS?
const COLOR_NUMBER_MAX = 10;
// TODO: what's a reasonable size for this?
const COLOR_COUNT_GROUP_SIZE = 30;

export default {
    computed: {
        startTimes() {
            return this.$store.state.eventCountsStartTimes;
        },
        eventCounts() {
            return this.$store.state.eventCounts;
        },
        // NOTE: must be computed because it depends on how many buckets we have
        cellWidth() {
            let availableSpace = this.heatmapWidth - this.margin.left -
                this.margin.right - this.titleColumnWidth;

            return (availableSpace / this.startTimes.length) - this.cellSpacing;
        },
    },
    data() {
        // TODO: nicer formatting for the titles
        let rowOrder = [
            'lldp',
            'ospf',
            'clag',
            'vlan',
            'bgp',
            'link',
            'sensor',
            'port',
        ];
        // TODO: make these a constant outside of the component?
        let margin = {}
        margin.top = 10;
        margin.bottom = 10;
        margin.left = 20;
        margin.right = 20;

        let rowHeight = 40;

        let titleColumnWidth = 50

        let cellSpacing = 2;

        let heatmapWidth = 500;
        let heatmapHeight = rowHeight * rowOrder.length + margin.bottom + margin.top;

        // TODO: play with how much border between cells
        let cellHeight = rowHeight - (cellSpacing * 2);

        return {
            cellHeight,
            cellSpacing,
            heatmapWidth,
            heatmapHeight,
            rowOrder,
            rowHeight,
            margin,
            titleColumnWidth,
        };
    },
    methods: {
        // TODO: have a prefix to suggest that this will be used in template?
        getRowTransform(rowIdx) {
            let x = this.margin.left;
            let y = (rowIdx + 1) * this.rowHeight + this.margin.top;
            return `translate(${x}, ${y})`;
        },
        getRectClass(colIdx, rowIdx) {
            let type = this.rowOrder[rowIdx];
            let totalCount = this.eventCounts[type][colIdx].total;

            let colorNumber = Math.floor(totalCount / COLOR_COUNT_GROUP_SIZE);
            if (colorNumber > COLOR_NUMBER_MAX) {
                colorNumber = COLOR_NUMBER_MAX;
            }
            // TODO: generate a style element with JS?
            return `heatmap-color${colorNumber}`;
        },
        getRectX(colIdx) {
            return this.titleColumnWidth + (colIdx * (this.cellWidth + this.cellSpacing));
        },
        getRectY(rowIdx) {
            // HACK: not sure why this works for alignment, but it does!
            return -(this.rowHeight * 0.6);
        },
    },
};
