import _ from 'lodash';

const ORDER_ASCENDING = 'asc';
const ORDER_DESCENDING = 'desc';

export default {
    props: {
        columns: Array,
    },
    data() {
        // TODO: sort before anything?
        let columnOrders = {};
        this.columns.forEach(function(key) {
            columnOrders[key] = ORDER_ASCENDING;
        });
        return {
            sortKey: '',
            columnOrders,
        };
    },
    computed: {
        // TODO: put this stuff in vuex
        sortedData() {
            let sortKey = this.sortKey;
            let order = this.columnOrders[sortKey];
            let data = this.rawData;
            if (sortKey) {
                data = _.orderBy(data, [function(obj) {
                    return obj[sortKey].value;
                }], [ order ]);
            }
            return data;
        },
        rawData() {
            // FIXME: tightly coupled with eventMessages
            return this.$store.state.eventMessages;
        },
    },
    methods: {
        sortBy(key) {
            let order = this.columnOrders[key];
            if (order === ORDER_ASCENDING) {
                order = ORDER_DESCENDING;
            } else {
                order = ORDER_ASCENDING;
            }
            this.sortKey = key;
            this.columnOrders[key] = order;
        },
    },
};
