import ListView from 'components/ListView.vue';
import EventsHeatMap from 'components/EventsHeatMap.vue';
import {
    ACTION_FETCH_EVENT_MESSAGES,
    ACTION_FETCH_EVENT_COUNTS,
} from 'store/action-types.js';
import {
    SET_START_TIME,
    SET_END_TIME,
} from 'store/mutation-types.js';

// FIXME: duplicated code
let options = {
    // keys from fetched JSON structure
    inKeys: [
        // NOTE: order here determines order of columns
        'timestamp',
        'source',
        'eventType',
        // TODO: mechanism for mapping numerical value to severity
        'severity',
        'message',
    ],
    // mappings to displayable keys/labels
    columnLabelMappings: {
        'timestamp': 'Time',
        'severity': 'Severity',
        'eventType': 'Type',
        'source': 'Source',
        'message': 'Message',
    },
};

// TODO: find a better place to put this?
const getColumnLabels = function(inKeys, columnLabelMappings) {
    let columnLabels = inKeys.map(function(key) {
        return columnLabelMappings[key];
    });
    return columnLabels;
}
// FIXME: this goes somewhere else
import { format } from 'date-fns';

export default {
    components: {
        ListView,
        EventsHeatMap,
    },
    data() {
        // HACK: data shouldn't have side effects
        // TODO: where should this go?
        this.$store.dispatch(ACTION_FETCH_EVENT_MESSAGES);
        this.$store.dispatch(ACTION_FETCH_EVENT_COUNTS);
        let data = {
            // TODO: clean this up
            columns: getColumnLabels(options.inKeys, options.columnLabelMappings),
            inputStartTime: this.$store.state.startTime,
            inputEndTime: this.$store.state.endTime,
        };
        return data;
    },
    computed: {
        startTime() {
            return this.$store.state.startTime;
        },
        endTime() {
            return this.$store.state.endTime;
        },
    },
    filters: {
        formatTime(timestamp) {
            // FIXME: duplicated in actions.js
            return format(timestamp * 1000, 'MMM D, YYYY HH:mm:ss');
        },
    },
    methods: {
        buttonSetOnClick(event) {
            this.$store.commit(SET_START_TIME, this.inputStartTime);
            this.$store.commit(SET_END_TIME, this.inputEndTime);
        },
        buttonCancelOnClick(event) {
            this.inputStartTime = this.startTime;
            this.inputEndTime = this.endTime;
        },
    },
};
