import Vue from 'vue';
import Vuex from 'vuex';
import mutations from 'store/mutations.js';
import actions from 'store/actions.js';

Vue.use(Vuex);

const isDebug = process.env.NODE_ENV !== 'production';

let store = new Vuex.Store({
    actions,
    mutations,
    state: {
        searchbarContents: '',
        // TODO: sane default times
        startTime: 1507782880,
        // TODO: sane default times
        endTime: 1507783105,
        //  TODO: split the events stuff into a module or somethiing?
        eventCountsStartTimes: [],
        eventCounts: {},
        eventMessages: [],
    },
    getters: {
        // TODO: add getters as they become necessary
    },
    modules: {
        // TODO: move things to module files as patterns emerge
    },
    strict: isDebug,
});

// enable hot module reloading on vuex store
if (module.hot) {
    module.hot.accept(
        [
            './mutations.js',
            './actions.js',
        ],
        function() {
            store.hotUpdate({
                actions: require('./actions.js'),
                mutations: require('./mutations.js'),
            });
        }
    );
}

export default store;
