import {
    UPDATE_SEARCHBAR_CONTENTS,
    EVENT_MESSAGES_UPDATE,
    EVENT_COUNTS_UPDATE,
    SET_START_TIME,
    SET_END_TIME,
} from 'store/mutation-types.js';

const mutations = {
    [UPDATE_SEARCHBAR_CONTENTS] (state, searchbarContents) {
        state.searchbarContents = searchbarContents;
    },
    [EVENT_MESSAGES_UPDATE] (state, eventMessages) {
        state.eventMessages = eventMessages;
    },
    [EVENT_COUNTS_UPDATE] (state, eventCountsData) {
        state.eventCountsStartTimes = eventCountsData.startTimes;
        state.eventCounts = eventCountsData.eventCounts;
    },
    [SET_START_TIME] (state, startTime) {
        state.startTime = startTime;
    },
    [SET_END_TIME] (state, endTime) {
        state.endTime = endTime;
    },
};

export default mutations;
